// Lamp.cpp: implementation of the CLamp class.
//
//////////////////////////////////////////////////////////////////////
#include <iostream>
#include "Lamp.h"
using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLamp::CLamp(CBulb *bp, CSwitch *sw) : b_ptr(bp), sw_ptr(sw) 
{
	cout << "Constructing lamp" << endl;
}

CLamp::~CLamp()
{
	cout << "Destructing lamp" << endl;

}

//////////////////////////////////////////////////////////////////////
// Lamp On
//////////////////////////////////////////////////////////////////////
void CLamp::on() 
{
	sw_ptr->close();
	b_ptr->on();
}

//////////////////////////////////////////////////////////////////////
// Lamp off
//////////////////////////////////////////////////////////////////////
void CLamp::off()
{
	sw_ptr->open();
	b_ptr->off();
}

//////////////////////////////////////////////////////////////////////
// Identify lamp condition
//////////////////////////////////////////////////////////////////////
void CLamp::identify() const
{
	if (sw_ptr->get_state() == 1)
	{
		cout << "lamp is on" << endl;
	}
	else
	{
		cout << "lamp is off" << endl;
	}
}

//////////////////////////////////////////////////////////////////////
// return lamp power usage
//////////////////////////////////////////////////////////////////////
int CLamp::getpower() const
{
	if(sw_ptr->get_state() == 1)
	{
		return b_ptr->get_power();
	}
	else
	{
		return 0;
	}
}

//////////////////////////////////////////////////////////////////////
// change bulb
//////////////////////////////////////////////////////////////////////
CBulb *  CLamp::change_bulb(CBulb * bp)
{
	CBulb *old = b_ptr; //"remove" old bulb
	b_ptr = bp;		//replace with nre bulb
	return old; // return old Bulb
}